import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;

import javax.swing.JTextField;


import org.lekan.graphics.GraphicsProgram;



/**
 * Who needs Google Maps when you have Pathfinder?
 * 
 * @author Melissa
 *
 */
public class Pathfinder extends GraphicsProgram {
	public static void main(String[] args) {
		new Pathfinder();
	}
	
	private static final String FILE_NAME = "USAmap-1000x618.png";
	
	// Constants
	private static final int CANVAS_WIDTH = 1000;
	private static final int CANVAS_HEIGHT = 618;
	private static String editButton = "Edit";
	private static String editText = "Edit Mode";
	private static String waypoint = "Waypoint";
	private static String destination = "Destination";
	private static String pathButton = "Path Mode";
	private static boolean isEditMode = false;
	private static boolean isWaypointMode = false;
	private static boolean isDestinationMode = false;
	private static boolean isPathMode = false;
	private static int editButtonX = 900;
	private static int editButtonY = 550;
	private static int startX = 0;
	private static int startY = 0;
	private static int pathX = 0;
	private static int pathY = 0;
	private static int endX = 0;
	private static int endY = 0;
	private JTextField wayText;
	private JTextField destText;
	private JTextField edgeText;
	
	// [YOUR DATA STRUCTURES WILL GO HERE]
	
	@Override
	public void setup() {
		// Setup code goes here
		this.getFrame().setTitle("Pathfinder BETA!");
		this.getFrame().setDimensions(CANVAS_WIDTH, CANVAS_HEIGHT);
		this.getFrame().drawImage(0, 0, FILE_NAME);
		this.addButton(editButton, WEST);
		this.addButton(waypoint, WEST);
		this.addButton(destination, WEST);
		this.addButton(pathButton, WEST);
		this.addButton("Clear", WEST);
		destText = new JTextField("Please enter name of destination, then create destination...",30);
		this.addTextField(destText, NORTH);
		wayText = new JTextField("Please enter name of waypoint, then create waypoint...",30);
		this.addTextField(wayText, NORTH);
		edgeText = new JTextField("Enter the cost of this travel path...",20);
		this.addTextField(edgeText,NORTH);
	}
	
	
	@Override
	public void run() {
		// Run code goes here
		
	}
	
	// Nodes
	private static class Node {
	//   - Set of edges
		String name;
		Set<Edge> edges;
		
		public Node(String name) {
			edges = new HashSet<Edge>();
			this.name = name;
		}
	}
	
	// Edges
	private static class Edge {
	//   - where it's from
	//   - where it's going
		double cost;
		Node node1;
		Node node2;
		
		public Edge(Node from, Node to, double cost) {
			this.node1 = from;
			this.node2 = to;
			this.cost = cost;
		}
	}
	
	private static List<String> destList = new ArrayList<String>();
	private static List<String> wayList = new ArrayList<String>();
	private static Map<String, int[]> destPosition = new HashMap<String, int[]>();
	private static Map<String, int[]> wayPosition = new HashMap<String, int[]>();
	private static List<Node> destinations = new ArrayList<Node>();
	private static List<Node> waypoints = new ArrayList<Node>();
	private static List<Edge> edges = new ArrayList<Edge>();
	

	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals(editButton))
			if (isEditMode == false){
				this.getFrame().setForegroundColor(Color.RED);
				this.getFrame().drawText(editText, editButtonX, editButtonY);
				isEditMode = true;
			}
			else if (isEditMode){
				this.getFrame().setForegroundColor(Color.WHITE);
				for (int k=0; k<6; k++){
					this.getFrame().drawText(editText, editButtonX, editButtonY);
				}
				isEditMode = false;
				isWaypointMode = false;
				isDestinationMode = false;
				isPathMode = false;
			}
		
		if (isEditMode){
			if (e.getActionCommand().equals(waypoint)){
				isWaypointMode = true;
				isDestinationMode = false;
				isPathMode = false;
				
			}
			if (e.getActionCommand().equals(destination)){
				isDestinationMode = true;
				isWaypointMode = false;
				isPathMode = false;
			}
			if (e.getActionCommand().equals(pathButton)){
				isPathMode = true;
				isWaypointMode = false;
				isDestinationMode = false;
			}
		}
		if (e.getActionCommand().equals("Clear")){
			this.getFrame().clearGraphics();
			this.getFrame().drawImage(0, 0, FILE_NAME);
			destList = new ArrayList<String>();
			wayList = new ArrayList<String>();
			destPosition = new HashMap<String, int[]>();
			wayPosition = new HashMap<String, int[]>();
			destinations = new ArrayList<Node>();
			waypoints = new ArrayList<Node>();
			edges = new ArrayList<Edge>();
			isEditMode = false;
			isWaypointMode = false;
			isDestinationMode = false;
			isPathMode = false;
		}
		if (isEditMode == false){
			if (destList.size() > 0){
				for (String item : destList) {
					destinations.add(new Node (item));
				}
			}
			if (wayList.size() > 0){
				for (String point : wayList){
					waypoints.add(new Node (point));
				}
			}
		}
	}
	
	@Override
	public void mouseClicked(MouseEvent e) {
		startX = e.getX();
		startY = e.getY();
		if (isWaypointMode){
			this.getFrame().setForegroundColor(Color.MAGENTA);
			this.getFrame().drawRect(startX, startY, 3, 3);
			this.getFrame().drawText(wayText.getText(), startX+5, startY+5);
			wayList.add(wayText.getText());
			waypoints.add(new Node(wayText.getText()));
			int[] coordinates = new int[2];
			coordinates[0] = startX;
			coordinates[1] = startY;
			wayPosition.put(wayText.getText(), coordinates);
			
		}
		if (isDestinationMode){
			this.getFrame().setForegroundColor(Color.BLUE);
			this.getFrame().drawRect(startX, startY, 5, 5);
			this.getFrame().drawText(destText.getText(), startX+7, startY+7);
			destList.add(destText.getText());
			destinations.add(new Node(destText.getText()));
			int[] coordinates = new int[2];
			coordinates[0] = startX;
			coordinates[1] = startY;
			destPosition.put(destText.getText(), coordinates);
			
		if (isPathMode){
			startX = e.getX();
			startY = e.getY();
		}
			
		}
	}
	public void mousePressed(MouseEvent e) {
		pathX = e.getX();
		pathY = e.getY();
	}
	public void mouseReleased(MouseEvent e) {
		endX = e.getX();
		endY = e.getY();
		double cost = -1.0;
		if (isPathMode){
			this.getFrame().setForegroundColor(Color.RED);
			boolean isCord1 = false;
			boolean isCord2 = false;
			boolean error = false;
			
			Node nodeFrom = new Node("");
			Node nodeTo = new Node("");
			
			try{
				cost = Double.parseDouble(edgeText.getText());
			}
			catch (NumberFormatException r){
				System.err.println("Please enter the cost of the edge as an integer");
				r.printStackTrace();
				error = true;
			}
			
			for (int i = 0; i < destinations.size(); i++ ){
				Node d = (destinations.get(i));
				int[] cord = destPosition.get(destList.get(i));
				for (int k = -10; k <= 10; k++){
					if (pathX + k == cord[0]){
						pathX = (pathX + k) + 5;
						pathY = (cord[1]) + 5;
						nodeFrom = d;
						isCord1 = true;
						break;
					}
					if (endX + k == cord[0]){
						endX = endX + k;
						endY = cord[1];
						nodeTo = d;
						isCord2 = true;
						break;
					}
					if (pathY + k == cord[1]) {
						pathY = (pathY + k) + 5;
						pathX = (cord[0]) + 5;
						nodeFrom = d;
						isCord1 = true;
						break;
					}
					if (endY + k == cord[1]){
						endY = endY + k;
						endX = cord[0];
						nodeTo = d;
						isCord2 = true;
						break;
					}
				}
			}
			
			if (isCord1 && isCord2 && error == false){
				this.getFrame().drawLine(pathX, pathY, endX, endY);
				this.getFrame().drawText(edgeText.getText(), (((pathX + endX)/2) + 3), (((pathY + endY)/2) + 3));
				edges.add(new Edge(nodeFrom, nodeTo, cost));
			}
			
			//System.out.println(Integer.parseInt(edgeText.getText()));
		}
	}
}

